#!/usr/bin/env python2
import geneParsers, re

def main():
    cer = geneParsers.loadFASTA('cerevisiae/orf_coding.fasta')
    par = geneParsers.loadFASTA('paradoxus/orf_genomic_1000.fasta')

    cerseqs = dict((seq.seqID, {'seq': seq.seq, 'desc': seq.description}) for seq in cer)
    for seq in par:
        hit = seq.description.split()[0].strip(',')
        if hit == 'Multiple':
            continue
        if hit in cerseqs and re.search('Verified ORF', cerseqs[hit]['desc']) and not re.search('Chr Mito', cerseqs[hit]['desc']):
            with open('hits/{}'.format(hit), 'wt') as f:
                print >>f, "> Cer"
                print >>f, cerseqs[hit]['seq']
                print >>f, "> Par"
                print >>f, re.sub('[acgt]', '', seq.seq)

if __name__ == '__main__':
    main()
