#!/usr/bin/env bash

dataset=0.9
./showNunique.sh >nUnique${dataset}.txt

mkdir -p dists64_${dataset}
mkdir -p plots64svg${dataset}
for i in ../rawData/alignedEM0.9/*
do
    tf=$(basename $i)
    echo "Getting Background for $tf"
    ./histIntergenic.py ../rawData/totIntergenic $i 64 >dists64_${dataset}/$tf
    ./IvsNplot.py dists64_${dataset}/$tf $i ../rawData/rawSites${dataset}/$tf plots64svg${dataset}/${tf}.svg
done

mkdir -p chenDataUnnormedPlotting${dataset}
mkdir -p chenDataUnnormedPrecise${dataset}
for i in ../rawData/alignedEM0.9/*
do
    tf=$(basename $i)
    echo "Generating Data for $tf"
    if [ ! -f ../rawData/rawSites${dataset}/$tf ]; then
        continue
    fi

    ./genDataUnnormed.py ../rawData/totIntergenic ../rawData/rawSites${dataset}/$tf $i 32768 >chenDataUnnormedPrecise${dataset}/$tf 
    ./genDataUnnormed.py ../rawData/totIntergenic ../rawData/rawSites${dataset}/$tf $i >chenDataUnnormedPlotting${dataset}/$tf
done
