#!/usr/bin/env python2
from pylab import *
from scipy import *
import sys, glob, os
import matplotlib.pyplot as plt
import matplotlib as mpl

def logFitnessNonlethal(mu,B,c,en):
    return logaddexp(B*(en-mu)+log(c),0) - logaddexp(B*(en-mu),0)

def nrm(x,dx):
    return x/(sum(x)*dx)

rcParams['figure.subplot.left'] = 0.15
rcParams['figure.subplot.bottom'] = 0.15
mpl.rc('text', usetex=False)
mpl.rc('font', **{'family':'sans-serif', 'sans-serif': 'Arial', 'serif': 'Times New Roman'})

with open('nUnique0.9.txt') as f:
    counts = [l.split() for l in f.readlines()]
    counts = [(int(a),int(b),c) for a,b,c in counts][::-1]
    #counts.sort(key=lambda x: x[0], reverse=True)
    tfdirs = [c for a,b,c in counts][:12]

figure(figsize=(6,4))

nR, nC = 3,4

for pn,tfdir in enumerate(tfdirs):
    print pn, tfdir
    tf = os.path.basename(tfdir)
    try:
        with open('chenDataUnnormedPlotting0.9/' +tf) as f:
            seqen = array([float(w) for w in f.readline().split()])
            prob = array([float(w) for w in f.readline().split()])
            dat = array([[float(w) for w in line.split()] for line in f.readlines()])
            xen, back = dat[:,0], dat[:,1]
            dx = xen[1] - xen[0]
            xbins = r_[xen - dx/2, xen[-1] + dx/2]
            n = back/(sum(back)*dx)
    except:
        print "Skipping ", tf
        continue
    #d = loadtxt('dists64/' + fn)
    #xen, n, i = d[:,0], d[:,1], d[:,2]
    #dx = xen[1] - xen[0]
    #xbins = r_[xen[0] - dx/2, xen+dx/2]
        
    h = histogram(seqen, bins=xbins, weights=prob, normed=True)[0]
    #h = h/(dx*sum(h))
    print sum(h)*dx, sum(n)*dx
    
    ax = subplot(nR,nC,pn+1)
    #plot(xen, log(h/n), '.')
    herr = sqrt(h*(1-h)/len(seqen))
    selerr = herr/h
    errorbar(xen, log(h/n), fmt='.', color='blue', yerr=selerr, ecolor='blue')
    xtl = ['','',''] if pn+1 <= (nR-1)*(nC) else [-20, -15,-10,-5]
    xticks([-20, -15,-10,-5], xtl)
    xlim(-15, -3)
    ytl = ['',''] if (pn%nC) != 0 else [0,5,10]
    yticks([0,5,10], ytl)
    ylim(-3.5,15)
    text(0.1,0.1,tf, transform =ax.transAxes)
    text(0.35,0.8,str(len(seqen)) + ' sites', transform =ax.transAxes)


figtext(0.02, 0.5, r'$\log \frac{\pi(E)}{\pi_0(E)}$', size='large', rotation='vertical')
figtext(0.525,0.02, r'$E$', size='large', horizontalalignment='center')

show()
    
