#!/usr/bin/env python2
from scipy import loadtxt, exp
import load, pylab
import sys

def main():
    try:
        if len(sys.argv) == 4:
            e = float(sys.argv[3])
            f = exp(-e*loadtxt(sys.argv[1]))
        else:
            f = loadtxt(sys.argv[1])
        bases = sys.argv[2]
        load.showFreqs(f, bases)
        pylab.show()
        return
    except Exception as e:
        print e
        pass

    if len(sys.argv) > 2:
        trialbases = [sys.argv[2]]
    else:
        trialbases = [None]
    trialbases.extend(["ACGT", "ABCDEFGHIJKLMNOPQRST"])
    for t in trialbases:
        try:
            seq,inf = load.loadSites(sys.argv[1], names=t)
            bases = inf[0]
            f = load.getFreqs(seq, len(bases))
            load.showFreqs(f, bases, seq.shape[0])
            pylab.show()
            return
        except Exception as e: 
            pass

    print "Usage: one of:"
    print "$logo.py sites"
    print "$logo.py sites bases"
    print "$logo.py freq bases"
    print "$logo.py em bases B"
    

if __name__ == '__main__':
    main()
