#!/usr/bin/env python2
import glob, sys, os, shutil
from scipy import *
import load
import pylab

def entropy(f):
    old_settings = seterr(divide='ignore', invalid='ignore')
    ret = sum(nan_to_num(f*log2(f)))
    seterr(**old_settings)
    return ret

def KLscore(fa, fb):
    old_settings = seterr(divide='ignore', invalid='ignore')
    ret = sum(nan_to_num(fa*log2(fa/fb)))
    seterr(**old_settings)
    return ret

def LLscore(fa, fb):
    old_settings = seterr(divide='ignore', invalid='ignore')
    ret = sum(nan_to_num(fa*log2(fb)))
    seterr(**old_settings)
    return ret

bases = 'ACGT'

emdir = sys.argv[1]
sitedir = sys.argv[2]
statsdir = sys.argv[3]

dat = []
tf = os.path.basename(statsdir)

em = loadtxt(os.path.join(emdir, tf))
seqLen, nBases = em.shape
sites, info = load.loadSites(os.path.join(sitedir, tf), names=bases)
nSeq = sites.shape[0]

emfreq = exp(-1.688*em)
emfreq = emfreq/sum(emfreq,1)[:,newaxis]
sitefreq = load.getFreqs(sites, 4)

fig = pylab.figure()
pylab.subplot(311)
load.showEnergies(-em, fig=fig)
pylab.ylabel('Energy Matrix')
pylab.xticks(arange(1,seqLen+1),['']*seqLen)
lim = pylab.axis()
pylab.yticks([lim[2],0,lim[3]])
pylab.subplot(312)
load.showFreqs(emfreq, bases, seqLen, fig)
pylab.ylabel('EM logo')
pylab.xticks(arange(1,seqLen+1),['']*seqLen)
lim = pylab.axis()
pylab.yticks([lim[2],0,lim[3]])
pylab.subplot(313)
load.showFreqs(sitefreq, bases, seqLen, fig)
pylab.ylabel('Seq. logo')
lim = pylab.axis()
pylab.yticks([lim[2],0,lim[3]])
pylab.savefig("{}/Logos.svg".format(statsdir, tf))
pylab.close()

nunique = len(set(tuple(s) for s in sites))
with open('{}/stats.txt'.format(statsdir), 'wt') as f:
    f.write("nseq: {}\nnunique: {}\nem-entropy: {}\nsite-entropy: {}\nKLdiff: {}".format(nSeq, nunique, entropy(emfreq), entropy(sitefreq),LLscore(emfreq,sitefreq)))



