#!/usr/bin/env python2
from __future__ import with_statement
from scipy import *
import pylab
import sys, re, glob, os

def main():
    sitedir = sys.argv[1]

    #load sgd feature file
    with open('./sgd/SGD_features.tab') as f:
        features = [l.split('\t') for l in f.readlines()]
    
    genenames = {}
    for feature in features:
        (sgdid,ftype,fqual,fname,gene,alias,parent,
         sgdid2,chrm,fstart,fend,fstrand,gpos,
         cver,sver,desc) = feature
        if ftype == 'ORF':    
            genenames[fname] = [x.strip() for x in [fname, gene] + [a for a in alias.split('|') if ' ' not in a] if x != '']
        
    f = open('genenames', 'wt')
    for k in genenames.keys():
        print >>f, " ".join(genenames[k])
    f.close()
            
    f = open('tf_gene_map', 'wt')

    for tff in glob.glob(os.path.join(sitedir,'*')):
        tf = re.match(os.path.join(sitedir,'(.*)'), tff).groups()[0]
        try:
            tfgene = (gene for gene,names in genenames.iteritems() if tf in names).next()
            print >>f, tf, tfgene
        except StopIteration:
            print >>sys.stderr, "Did not find a gene for " + tf
    f.close()

if __name__ == '__main__':
    main()

