#!/usr/bin/env python2
from scipy import *
import sys, glob, os
import pylab

fig = pylab.figure(figsize=(10,3))
fig.subplots_adjust(left=0.1, right=0.95, top=0.95, wspace=0.5, bottom=0.2, hspace=0.5)

datadir = sys.argv[1]

runfiles = glob.glob(os.path.join(datadir, '/fits/*'))
mus = []
Bs = []
gs = []
lls = []
minimums = []
for d in runfiles:
    try:
        with open(d) as f:
            N,mu,B,c,ll = f.readline().split()
        mus.append(float(mu))
        Bs.append(float(B))
        gs.append(float(N)*(1-float(c)))
        lls.append(float(ll))
    except: 
        pass

tf = os.path.basename(datadir)
print tf
gridData = False
with open(os.path.join('../yeastfit/fit/', tf, 'gridfit')) as f:
    txt = f.readline().split()
    fit4 = [float(x) for x in txt[:4]]
    ll4 = float(txt[4])
    gamma4 = fit4[0]*(1-fit4[3])
gs = array(gs)

fc = '#8888ff'

pylab.subplot(131)
pylab.axvline(fit4[1], color='r', linestyle='--', lw=2)
h,x,p = pylab.hist(mus, bins=30, facecolor=fc)
pylab.xlabel(r'$\mu$')
pylab.ylabel('#')
pylab.ylim(0, max(h)*1.5)
pylab.subplot(132)
h,x,p = pylab.hist((Bs), bins=30, facecolor=fc)
pylab.axvline((fit4[2]), color='r', linestyle='--', lw=2)
pylab.xlabel(r'$\beta$')
pylab.ylim(0, max(h)*1.5)
pylab.subplot(133)
print gamma4
cutoffs = {'REB1': 40.0, 'BAS1': 50.0, 'YAP7': 30.0, 'STB5': 1000, 'AFT1': 100.0}
print gs
if tf in cutoffs:
    cutoff = cutoffs[tf]
    print gs[gs < cutoff]
    h,x,p = pylab.hist(gs[gs < cutoff], bins=arange(0,cutoff, cutoff/30), facecolor=fc)
    nh = max(h)*0.75
    pylab.xlim(0,1.2*cutoff)
    #for (n,g) in enumerate(gs[gs > cutoff]):
    #    pylab.annotate("%.1g" %g, (1.2*cutoff,nh*0.2*n + nh/2), xytext=(0.85*cutoff,nh*0.2*n+nh/2), arrowprops=dict(facecolor='black', shrink=0.01), va='center')
    #pylab.xticks([0,50000,100000, 150000])
    pylab.annotate("%d others" % sum(gs >= cutoff), (1.2*cutoff, nh/2), xytext=(0.65*cutoff,nh/2), arrowprops=dict(facecolor='black', shrink=0.01), va='center')
else:
    h,x,p = pylab.hist((gs), bins=30, facecolor=fc)
pylab.axvline((gamma4), color='r', linestyle='--', lw=2)
pylab.xlabel(r'$\gamma$')
pylab.ylim(0, max(h)*1.5)

pylab.tight_layout()

pylab.show()


