#!/usr/bin/env python2
import sys
from scipy import *
import numpy as np
import pylab, matplotlib

pylab.rcParams['figure.subplot.bottom'] = 0.15
pylab.rcParams['savefig.dpi'] = 300
formatter = matplotlib.ticker.ScalarFormatter(useOffset=False)

def loadGridFit(filename):
    with open(filename) as f:
        dat = f.readlines()
    fullmin = [float(x) for x in dat[0].split()]
    nonlethalmin = [float(x) for x in dat[2].split()]

    Bll = array([[float(x) for x in l.split()] for l in dat[4:24]])
    mull = array([[float(x) for x in l.split()] for l in dat[26:126]])
    
    f0 = array([float(x) for x in dat[128].split()])
    nu = array([float(x) for x in dat[129].split()])
    f0nu = array([[float(x) for x in l.split()] for l in dat[131:231]])
    return fullmin, nonlethalmin, Bll, mull, (f0,nu,f0nu)

#f0nu_ins = loadGridFit(sys.argv[1])[4]
fullmin, nonlethalmin, Bll, mull, f0nu = loadGridFit(sys.argv[2])
f0nu_ins = f0nu

#so is the f0-nu plot:
pylab.figure(figsize=(4.5,3))
cmax = np.max(f0nu[2].flatten())
cmin =  min(sort(f0nu[2].flatten())[-int(f0nu[2].size*0.17)], cmax-2)
pylab.pcolor(log(f0nu[1]), -log(1-f0nu[0]), f0nu[2], vmin=cmin, vmax=cmax, rasterized=True)
pylab.xlim(0,11)
pylab.ylim(0,9)
pylab.ylabel(r'$-\log(1-f_0)$')
pylab.xlabel(r'$\log(\nu)$')
c = pylab.colorbar(format=formatter)
c.set_label('Log Likelihood')
c.solids.set_rasterized(True) 
c.solids.set_antialiased(False)
pylab.ticklabel_format(useOffset=False)
pylab.subplots_adjust(right=0.8)

ax = pylab.axes((0.27,0.65,0.2,0.2))
pylab.pcolor(log(f0nu_ins[1]), -log(1-f0nu_ins[0]), f0nu_ins[2], vmin=cmin, vmax=cmax, rasterized=True)
#xends = (0.5, 1.5)
#yends = (0,0.05)
xends = (0.0, 1.2)
yends = (0,0.05)
x1, x2, y1, y2 = [float(x) for x in sys.argv[3:7]]
pylab.xlim(x1,x2)
pylab.ylim(y1,y2)
ax.spines['bottom'].set_color('white')
ax.spines['top'].set_color('white')
ax.spines['left'].set_color('white')
ax.spines['right'].set_color('white')
for t in ax.xaxis.get_ticklines(): t.set_color('white')
for t in ax.yaxis.get_ticklines(): t.set_color('white')
pylab.xticks((x1,x2), color='white')
pylab.yticks((y1,y2), ["%.4g" % v for v in (y1,y2)], color='white')
#pylab.colorbar()

pylab.savefig(sys.argv[7])

pylab.show()
